import waba.fx.*;     // Graphics
//import waba.io.*;
//import waba.sys.*;    // Convert
import waba.ui.*;
//import waba.util.*;   // Vector
import extra.ui.Title;

// Random

/**
 * @author <A HREF="mailto:weyer@kagi.com">Steve Weyer</A>
 * Copyright (c) 2001, S. Weyer. All right reserved.
 * @version waba 1.0
 * !!!c ?? Mar 2001 elim drawDots
 * !!!b 13 Mar 2001
 * !!!a 12 Mar 2001
 * <A HREF="http://www.kagi.com/weyer/#Waba">Steve's other Waba apps</A>
 *
 * ?? getRandom(2) or (4)
**/

public class Jumble extends MainWindow {
  private static final boolean DEBUG = false;

  private static final int COMPHT  = 15;
  private static final int COMPWID = 52;
  private static final int COMPSEP = 2;

  final int ROWLETTERS = 12;
  final int NUMROWS = 3;
  final int MAXLETTERS = ROWLETTERS * NUMROWS;
  final int lineTop = 18;
  final int lineLeft = 2;
  final int letHt = 18;
  final int letWid = 13;
  final int markHt = 10;
  final int lineHt = 48;
  private int lastEdit = -1;
  private int curEdit = -1;   // current 'edit field'

  private char[] letter = new char[MAXLETTERS];
  private boolean[] marked = new boolean[MAXLETTERS];
  private Button jumble1Button;
  private Button jumble2Button;
  private Button jumble3Button;
  private Button jumble4Button;
  private Button jumbleAButton;
  private Button copyButton;
  private Button clearAllButton;
  private Random rand;
  private Graphics appG = null; // used for showCursor
  private Font jumbleFont;

  public Jumble() {
    int objX = 0, objY = 0, objWid;

    Title title = new Title("Jumble");
    title.setRect(objX, objY, this.width, COMPHT+1);
    add(title);

    Label lbl = new Label("weyer@kagi.com");
    lbl.setRect(42, objY, 80, COMPHT);
    add(lbl);

    objWid = COMPWID-8;
    objX = this.width-objWid;
    clearAllButton = new Button("Clear All");
    clearAllButton.setRect(objX, objY, objWid, COMPHT);
    add(clearAllButton);

    objY = lineTop+letHt+markHt+COMPSEP;
    objWid = COMPWID;
    objX = 40 - (objWid/2);
    int objX2 = 120 - (objWid/2);
    jumble1Button = new Button("Jumble 1");
    jumble1Button.setRect(objX,objY,objWid,COMPHT);
    add(jumble1Button);

    jumble2Button = new Button("Jumble 2");
    jumble2Button.setRect(objX2,objY,objWid,COMPHT);
    add(jumble2Button);

    objY += lineHt;
    jumble3Button = new Button("Jumble 3");
    jumble3Button.setRect(objX,objY,objWid,COMPHT);
    add(jumble3Button);

    jumble4Button = new Button("Jumble 4");
    jumble4Button.setRect(objX2,objY,objWid,COMPHT);
    add(jumble4Button);

    objY += lineHt;
    copyButton = new Button("Copy 1-4");
    copyButton.setRect(objX,objY,objWid,COMPHT);
    add(copyButton);

    jumbleAButton = new Button("Jumble A");
    jumbleAButton.setRect(objX2,objY,objWid,COMPHT);
    add(jumbleAButton);

    charFill(letter, 0, ' ');
    boolFill(marked, 0, false);
    rand = new Random();
  }

  public void onPaint(Graphics g) {
    jumbleFont = new Font(defaultFont.getName(), Font.PLAIN, 18);
    g.setFont(jumbleFont);
    FontMetrics fm = getFontMetrics(jumbleFont);
    if (appG == null) { // first time (doesn't work in MRJ if in constructor)
      appG = createGraphics();  // for showCursor, showLetter
      appG.setFont(jumbleFont);       // for showLetter
    };
    //g.setColor(255,255,255);  // white
    //g.fillRect(0, lineTop, this.width, this.width-lineTop);
    g.setColor(0,0,0);        // black

    char ch;
    int objX, objY = lineTop, i = 0, mid = ROWLETTERS/2 - 1;
    for (int row=0; row < NUMROWS; row++) {
      objX = lineLeft;
      for (int col=0; col < ROWLETTERS; col++) {
        if (col==0)
          g.drawLine(objX,        objY+6,     objX,        objY+letHt);  // |-
        if (row < NUMROWS-1 && col == mid)
          g.fillRect(objX+letWid-1, objY, 3, letHt);  //   -|  thicker&longer 'line'
        else
          g.drawLine(objX+letWid, objY+6,     objX+letWid, objY+letHt);  //   -|
        //g.drawDots(objX,         objY+letHt, objX+letWid, objY+letHt);   //  --

        ch = letter[i];
        if (ch != ' ') // draw char 'centered'
          g.drawText(String.valueOf(ch), objX+1+ (letWid - fm.getCharWidth(ch))/2, objY);
        if (curEdit == i)
          g.drawCursor(objX,objY,letWid+1,letHt); // see showCursor
        if (marked[i])
          g.fillRect(objX,objY+letHt,letWid,markHt);
        else
          g.drawRect(objX,objY+letHt,letWid+1,markHt);
        objX += letWid;
        i++;
      };
      objY += lineHt;
    };
    g.setFont(defaultFont); // revert for Title
  }
  public void showCursor() { // hide/show cursor. faster than complete repaint
    if (curEdit < 0)
      return;
    int col = curEdit % ROWLETTERS;
    int row = curEdit / ROWLETTERS;
    appG.drawCursor(lineLeft + col*letWid, lineTop + row*lineHt, letWid+1, letHt);
  }

/*
  public void showMarked() {
  }
  public void showLetter() { // fill a single field. faster than complete repaint
    int col = curEdit % ROWLETTERS;
    int row = curEdit / ROWLETTERS;
    int objX = lineLeft + col*letWid;
    int objY = lineTop + row*lineHt;
    appG.setColor(255,255,255);
    appG.fillRect(objX,objY,letWid,letHt);  // less to preserve lines?
    appG.setColor(0,0,0);
    char ch = letter[curEdit];
    if (ch != ' ') // draw char 'centered'
      appG.drawText(String.valueOf(ch),
        objX+1+ (letWid - getFontMetrics(jumbleFont).getCharWidth(ch))/2, objY);
    appG.drawCursor(objX, objY, letWid, letHt); // showCursor
  }
*/
  public void onEvent(Event ev) {
    Object obj = ev.target;
    int evType = ev.type;
    if (evType == ControlEvent.PRESSED) {
      if (obj == jumble1Button)
        jumble(0,6);
      else if (obj == jumble2Button)
        jumble(6,6);
      else if (obj == jumble3Button)
        jumble(12,6);
      else if (obj == jumble4Button)
        jumble(18,6);
      else if (obj == jumbleAButton)
        jumble(24,12);
      else if (obj == copyButton)
        copyMarked(24,12);
      else if (obj == clearAllButton) {
        charFill(letter, 0, ' ');
        boolFill(marked, 0, false);
      };
      repaint();
    }
    else if (obj == this && ev instanceof PenEvent) {
      int y = ((PenEvent) ev).y - lineTop;
      int col = (((PenEvent) ev).x - lineLeft) / letWid;
      int row = y / lineHt;
      if (row < 0 || row >= NUMROWS  || col < 0 || col >= ROWLETTERS)
        return;
      y %= lineHt;
      boolean lettop = false;
      if (y <= letHt)
        lettop = true;
      else if (y > letHt+markHt)
        return;
      int i = col + (row * ROWLETTERS);

      if (evType == PenEvent.PEN_DOWN)
        lastEdit = i; // save for pen up
      else if (evType == PenEvent.PEN_UP) {
        if (lettop) {  // letter on top
          if (lastEdit != i) { // swap
            curEdit = i;
            charSwap(letter,lastEdit,curEdit);
            boolSwap(marked,lastEdit,curEdit);
            repaint();
          }
          else { // move cursor only
            showCursor(); // hide
            curEdit = i;
            showCursor(); // show
          };
        }
        else  { // mark box
          marked[i] = ! marked[i];  // invert
          repaint();    // ?? showMarked()
        };
      };
    }
    else if (evType == KeyEvent.KEY_PRESS && curEdit >= 0) {
      int key = ((KeyEvent) ev).key, inc = 0;
      char ch = (char) key;
      if (key == IKeys.RIGHT || key == IKeys.TAB || key == 9)
        inc = 1;
      else if (key == IKeys.LEFT)
        inc = -1;
      else if (key == IKeys.UP)
        inc = -ROWLETTERS;
      else if (key == IKeys.DOWN)
        inc = ROWLETTERS;
      else if (key == IKeys.BACKSPACE) {
        ch = ' ';
        inc = -1;
      }
      else if (key == IKeys.DELETE)
        ch = ' ';
      else if ('a' <= ch && ch <= 'z') //IsLower(ch)
        ch += 'A'-'a';

      if (ch == ' ' || ('A' <= ch && ch <= 'Z')) { //IsUpper(ch)
        letter[curEdit] = ch;
        repaint();  // ?? showLetter();
      };

      if (inc != 0) {
        showCursor(); // hide
        curEdit += inc;
        if (curEdit < 0)
          curEdit = MAXLETTERS+curEdit;
        else if (curEdit >= MAXLETTERS)
          curEdit = curEdit % MAXLETTERS;
        showCursor(); // show
      };
    }
  }

  public void jumble(int start, int count) {
    int last = start, r;
    char ch;
    // "trim" (shift left, omitting spaces)
    for (int i = start; i < start+count; i++)
      if ((ch = letter[i]) != ' ') {
        if (i > last) {
          letter[last] = ch;
          marked[last] = marked[i];
        };
        last++;
      };

    // shuffle (except marked)
    for (int i = start; i < start+count; i++)
      if (i < last) {
        if (! marked[i] && i != (r = rand.getRandom(last-start)+start) && !marked[r])
          charSwap(letter,i,r);
      }
      else { // fill
        letter[i] = ' ';
        marked[i] = false;
      };
  }

  public void copyMarked(int start, int count) {
    int len = 0;
    for (int i = 0; i < start; i++)
      if (marked[i]) {
        letter[start+len] = letter[i];
        len++;
        if (len >= count)
          break;
      };
    charFill(letter, start+len, ' ');
    boolFill(marked, start,     false);
  }

  public static void charFill(char[] chars, int start, char ch) {
    for (int i=start; i < chars.length; i++)
      chars[i] = ch;
  }

  public static void boolFill(boolean[] bools, int start, boolean bool) {
    for (int i=start; i < bools.length; i++)
      bools[i] = bool;
  }

  public static void charSwap(char[] chars, int i, int j) {
    char ch = chars[i];
    chars[i] = chars[j];
    chars[j] = ch;
  }

  public static void boolSwap(boolean[] bools, int i, int j) {
    boolean bool = bools[i];
    bools[i] = bools[j];
    bools[j] = bool;
  }
}
